local FriendsAlert = CreateFrame("Frame", "FriendsAlert")
local default_settings = {}
FriendsAlert_SavedOptions = {}
local settings = default_settings
local BNGetNumFriends = BNGetNumFriends
local lastAlert = {}
local friendsListCache = {}

FriendsAlert:RegisterEvent("ADDON_LOADED")

FriendsAlert:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" and select(1, ...) == "FriendsAlert" then
		FriendsAlert:RegisterEvent("BN_FRIEND_ACCOUNT_ONLINE")
		FriendsAlert:RegisterEvent("PLAYER_ENTERING_WORLD")
		FriendsAlert:RegisterEvent("BN_FRIEND_LIST_SIZE_CHANGED")
		settings = FriendsAlert_SavedOptions or default_settings
	elseif event == "BN_FRIEND_ACCOUNT_ONLINE" then
		local ID = select(1, ...)
		local accountInfo = C_BattleNet.GetAccountInfoByID(id) 
		if accountInfo and accountInfo.gameAccountInfo then
			if settings[accountInfo.battleTag] == true then
				if not IsEncounterInProgress() then--Do not do sound alert during raid boss fight
					if lastAlert[accountInfo.battleTag] and GetTime() - lastAlert[accountInfo.battleTag] < 60 then return end--don't alert for same friend more than once every 60 seconds (in case they are switching between toons really fast or something)
					lastAlert[accountInfo.battleTag] = GetTime()
					PlaySoundFile("Sound\\Event Sounds\\OgreEventCheerUnique.ogg", "Master")
				end
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		for i=1, BNGetNumFriends() do
			local presenceID, name, battleTag = BNGetFriendInfo(i)
			local accountInfo = _G.C_BattleNet.GetFriendAccountInfo(friendIndex)
			if accountInfo and accountInfo.battleTag and accountInfo.battleTag ~= "" then
				friendsListCache[i] = accountInfo.battleTag
			else
				FriendsAlert:Print("Could not cache ".. accountInfo.accountName .." because they have not created a btag yet")
			end
		end
		FriendsAlert:Print("Counted "..#friendsListCache.." total friends")--This works
	elseif event == "BN_FRIEND_LIST_SIZE_CHANGED" then
		FriendsAlert:Print("|cffff0000Your friends list size has changed|r")--the ONLY fucking thing that works
--[[		local tempCache = friendsListCache--Copy the cached complete friends list (this works)
		for i=1, BNGetNumFriends() do
			local presenceID, name, battleTag = BNGetFriendInfo(i)
			if battleTag and battleTag ~= "" then
				--non functional, for some reason this code doesn't remove a single item from table
				if tempCache[i] and tempCache[i] == battleTag then
					tempCache[i] = nil--Remove names from the cached list (if it even remotely worked)
				end
			end
		end
		--Only names left would be whomever deleted you, if it worked at all
		print(#tempCache)
		--non functiona. I could not find any working code that prints a table
		for i, v in ipairs(tempCache) do
			FriendsAlert:Print("|cff0000ff"..v.."'s|r might have deleted you")
		end--]]
	end
end)

--BNSendFriendInvite(btag/realid, Note)
function FriendsAlert:Print(text)
	_G.DEFAULT_CHAT_FRAME:AddMessage("|cFF33FF99FriendsAlert|r: ".. tostring(text))
end

----------------------
--  Slash Commands  --
----------------------
SLASH_FRIENDSALERT1 = "/friendsalert"
SlashCmdList["FRIENDSALERT"] = function(msg)
	local cmd = msg:lower()
	if cmd:sub(1, 3) == "add" then
		local btag = msg:sub(5)
		if btag then
			settings[btag] = true
			FriendsAlert:Print("|cFF088A08"..btag.."|r has been added to watch.")
		else
			FriendsAlert:Print("|cFF088A08BattleTag|r must be provided (even if it's a realid friend. This mod can only scan battletags since realname is encoded). You can find a friends BTag with /dump BNGetFriendInfo(i) where i is their position in friends list at this moment. It will be 3rd return.")
		end
	elseif cmd:sub(1, 6) == "remove" then
		local btag = msg:sub(8)
		if btag then
			settings[btag] = nil
			FriendsAlert:Print("|cffff0000"..btag.."|r has been removed from watch.")
		else
			FriendsAlert:Print("|cFF088A08BattleTag|r must be provided.")
		end
	elseif cmd:sub(1, 9) == "findbtags" then
		for i=1, select(2, BNGetNumFriends()) do
			local accountInfo = _G.C_BattleNet.GetFriendAccountInfo(friendIndex)
			if accountInfo then
				local bTag
				if accountInfo.battleTag and accountInfo.battleTag ~= "" then
					bTag = "|cFF088A08".. accountInfo.battleTag .."|r"
				else
					bTag = "|cffff0000not yet created|r"
				end
				FriendsAlert:Print("|cff0000ff".. accountInfo.accountName .."'s|r BattleTag is "..bTag)
			end
		end
	elseif cmd:sub(1, 12) == "findallbtags" then
		for i=1, BNGetNumFriends() do
			local accountInfo = _G.C_BattleNet.GetFriendAccountInfo(friendIndex)
			if accountInfo then
				local bTag
				if accountInfo.battleTag and accountInfo.battleTag ~= "" then
					bTag = "|cFF088A08".. accountInfo.battleTag .."|r"
				else
					bTag = "|cffff0000not yet created|r"
				end
				FriendsAlert:Print("|cff0000ff".. accountInfo.accountName .."'s|r BattleTag is "..bTag)
			end
		end
	elseif cmd:sub(1, 4) == "help" then
		FriendsAlert:Print("'/friendsalert add <btag>'. This will add a friend to FriendsAlert watch list. |cffff0000NOTE: This is case sensitive.|r")
		FriendsAlert:Print("'/friendsalert remove <btag>'. This will remove a friend from FriendsAlert watch list. |cffff0000NOTE: This is case sensitive.|r")
		FriendsAlert:Print("'/friendsalert list'. This will list all friends on FriendsAlert watch list.")
		FriendsAlert:Print("'/friendsalert findbtags'. This will help you find BattleTags for all online friends")
		FriendsAlert:Print("'/friendsalert findallbtags'. This will help you find BattleTags for all online & offline friends")
	elseif cmd:sub(1, 4) == "list" then
		FriendsAlert:Print("Alert List")
		FriendsAlert:Print("|cffff0000NOTE: This will fail to list btags that do not match contacts on battle.net friends list.|r")
		for i=1, BNGetNumFriends() do
			local accountInfo = _G.C_BattleNet.GetFriendAccountInfo(friendIndex)
			if accountInfo then
			if accountInfo and accountInfo.battleTag and settings[accountInfo.battleTag] then
				FriendsAlert:Print(accountInfo.battleTag)
			end
		end
	else
		FriendsAlert:Print("Not a valid input. Do '/friendsalert help' for more information.")
	end
end
